unit ltr114_Unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, SyncObjs,
  ltrapi,ltr114api,ltr114_ProcessThreadUnit, ltrapidefine,ltrapitypes, Spin;
type
    

    TLTR114TestForm = class(TForm)
    StartButton: TButton;
    StopButton: TButton;
    LTRSettingsGroup: TGroupBox;
    AutocbrModeBox: TComboBox;
    Label1: TLabel;
    FreqEdit: TEdit;
    FreqDividerSpin: TSpinEdit;
    Label2: TLabel;
    Label3: TLabel;
    SyncModeBox: TComboBox;
    Label4: TLabel;
    IntervalSpin: TSpinEdit;
    Label5: TLabel;
    ResultsGroup: TGroupBox;
    LCh1Edit: TEdit;
    Label6: TLabel;
    LCH1_GainBox: TComboBox;
    LCH1_ModeBox: TComboBox;
    LChCntEdit: TSpinEdit;
    Label7: TLabel;
    LCh2Edit: TEdit;
    LCH2_GainBox: TComboBox;
    LCH2_ModeBox: TComboBox;
    Label8: TLabel;
    LCh3Edit: TEdit;
    LCH3_GainBox: TComboBox;
    LCH3_ModeBox: TComboBox;
    Label9: TLabel;
    LCh4Edit: TEdit;
    LCh4_GainBox: TComboBox;
    LCH4_ModeBox: TComboBox;
    Label10: TLabel;
    ThermCheckBox: TCheckBox;
    ThermEdit: TEdit;
    LCH1_ChannelBox: TComboBox;
    LCH2_ChannelBox: TComboBox;
    LCH3_ChannelBox: TComboBox;
    LCH4_ChannelBox: TComboBox;
    CratesBox: TComboBox;
    ModulesBox: TComboBox;
    FindLtrButton: TButton;
    procedure StartButtonClick(Sender: TObject);
    procedure FreqDividerSpinChange(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FindLtrButtonClick(Sender: TObject);
    procedure CratesBoxChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    crit_sect : TCriticalSection ;
    thread_run : boolean;
    ltr114_thread :LTR114_ProcessThread;
    hltr114: TLTR114;

    procedure ButtonEndis(start : boolean);
    procedure OnThreadTerminate(par: TObject);
    function SetChannel(index : integer):LTR114_LCHANNEL;
    function ThreadIsRun() : boolean;

  public
    { Public declarations }
  end;

var
  LTR114TestForm: TLTR114TestForm;

implementation

{$R *.dfm}
///  StartTest/StopTest     (   )
procedure TLTR114TestForm.ButtonEndis(start : boolean);
begin
    if (start) then
    begin
        StartButton.Enabled :=false;
        StopButton.Enabled := true;
    end
    else begin
        StartButton.Enabled :=true;
        StopButton.Enabled := false;
    end;
end;

//     i ( 0-) c     
//      4 . ,     
function TLTR114TestForm.SetChannel(index:integer):LTR114_LCHANNEL;
var
    range_arr : array [0..LTR114_ADC_RANGEQNT-1] of integer;
    measmode_arr:array [0..2] of integer;
begin
    //         
    range_arr[0] := LTR114_URANGE_10;
    range_arr[1] := LTR114_URANGE_2;
    range_arr[2] := LTR114_URANGE_04;
    measmode_arr[0] := LTR114_MEASMODE_U;
    measmode_arr[1] := LTR114_MEASMODE_R;
    measmode_arr[2] := LTR114_MEASMODE_NR;

   case (index) of
    0: Result:=LTR114_CreateLChannel(measmode_arr[LCH1_ModeBox.ItemIndex], LCH1_ChannelBox.ItemIndex, range_arr[LCH1_GainBox.ItemIndex]);
    1: Result:=LTR114_CreateLChannel(measmode_arr[LCH2_ModeBox.ItemIndex], LCH2_ChannelBox.ItemIndex, range_arr[LCH2_GainBox.ItemIndex]);
    2: Result:=LTR114_CreateLChannel(measmode_arr[LCH3_ModeBox.ItemIndex], LCH3_ChannelBox.ItemIndex, range_arr[LCH3_GainBox.ItemIndex]);
    3: Result:=LTR114_CreateLChannel(measmode_arr[LCH4_ModeBox.ItemIndex], LCH4_ChannelBox.ItemIndex, range_arr[LCH4_GainBox.ItemIndex]);
   else
      Result:=LTR114_CreateLChannel(0,0,0);
   end;
end;


// StartTest -      
//LTR114_ProcessThread   
procedure TLTR114TestForm.StartButtonClick(Sender: TObject);
var
  res : integer;
  addr, slot : integer;
  slot_str : string;
  i : integer;
  ser_num_str : PChar;
begin
  ButtonEndis(true);
  addr := 0;
  LTR114_Init(@hltr114);

  slot_str := ModulesBox.Items[ModulesBox.ItemIndex];
  Delete(slot_str,1,5);   //  slot
  slot := StrToInt(slot_str);
  ser_num_str := PChar(CratesBox.Items[CratesBox.ItemIndex]);
  // .          SlotSpin
  res := LTR114_Open(@hltr114, SADDR_DEFAULT, SPORT_DEFAULT,ser_num_str , slot);

  if (res = LTR_OK) then
      res := LTR114_GetConfig(@hltr114);   //   
  if (res = LTR_OK) then
  begin
      // 
      hltr114.LChQnt := LChCntEdit.Value;
      for i:=0 to hltr114.LChQnt do
          hltr114.LChTbl[i] := self.SetChannel(i);
      hltr114.Interval := IntervalSpin.Value;
      if (ThermCheckBox.Checked) then
          hltr114.SpecialFeatures := LTR114_FEATURES_THERM
      else
          hltr114.SpecialFeatures := 0;
      hltr114.AdcOsr := 0;
      hltr114.FreqDivider := FreqDividerSpin.Value;

      if (SyncModeBox.Text = 'Internal') then
          hltr114.SyncMode := LTR114_SYNCMODE_INTERNAL
      else if (SyncModeBox.Text = 'Master') then
          hltr114.SyncMode := LTR114_SYNCMODE_MASTER
      else
          hltr114.SyncMode := LTR114_SYNCMODE_EXTERNAL;
      res := LTR114_SetADC(@hltr114);        //   
  end;

  if (res = LTR_OK) then
  begin
      //     
      ltr114_thread := LTR114_ProcessThread.Create(true);

      //    ,         
      ltr114_thread.LChEdits[0] := LCh1Edit;
      ltr114_thread.LChEdits[1] := LCh2Edit;
      ltr114_thread.LChEdits[2] := LCh3Edit;
      ltr114_thread.LChEdits[3] := LCh4Edit;
      ltr114_thread.ThermEdit := ThermEdit;
      ltr114_thread.pltr114 := @hltr114; //   ltr114
       // ,     
      ltr114_thread.OnTerminate :=  OnThreadTerminate;

      ltr114_thread.ltr_correction_mode := AutocbrModeBox.ItemIndex+1; //   
      ltr114_thread.FreeOnTerminate := true;

      crit_sect.Enter();
      ltr114_thread.Resume();  // 
      thread_run :=true;
      crit_sect.Leave();
  end;

  if (res<>LTR_OK) then
  begin
      Application.MessageBox(LTR114_GetErrorString(res), 'LTR114 Error');
      LTR114_Close(@hltr114);
      ButtonEndis(false);
  end;
end;


//    
procedure TLTR114TestForm.FreqDividerSpinChange(Sender: TObject);
begin
  FreqEdit.Text := FloatToStr(LTR114_CLOCK*1000/(LTR114_ADC_DIVIDER * FreqDividerSpin.Value));
end;

//,      
//  ,  thread_run
procedure TLTR114TestForm.OnThreadTerminate(par : TObject);
begin
    StopButton.Enabled := false;
    crit_sect.Enter();
    thread_run := false;
    crit_sect.Leave();
    StartButton.Enabled := true;
end;

// StopButton -    LTR114_STATUS_STOPPED
//       
procedure TLTR114TestForm.StopButtonClick(Sender: TObject);
begin
   StopButton.Enabled := false;
   ltr114_thread.SetLtrStatus(LTR114THREAD_STATUS_FORCE_STOP);
end;

procedure TLTR114TestForm.FormCreate(Sender: TObject);
begin
  crit_sect := TCriticalSection.Create;
  thread_run :=false;
  FindLtrButtonClick(self);
end;


//   FindLtr -    
procedure TLTR114TestForm.FindLtrButtonClick(Sender: TObject);
var
  hltr : TLTR;
  res,i : integer;
  LTR_Crates:array[0..CRATE_MAX-1]of array[0..SERIAL_NUMBER_SIZE-1] of char;  //   
begin
    LTR_Init(@hltr);
    hltr.cc := CC_CONTROL;    //  
    CratesBox.Items.Clear();

    res := LTR_Open(@hltr);
    if (res = LTR_OK) then
      res:=LTR_GetCrates(@hltr, @LTR_Crates); //  
    if (res = LTR_OK) then
    begin
        for i:=0 to CRATE_MAX-1 do
            if (LTR_Crates[i][0]<>'') then   //     
                CratesBox.Items.Add(string(LTR_Crates[i]));
    end;

    LTR_Close(@hltr);
    if (res<>LTR_OK) then   //    . 
        Application.MessageBox(LTR114_GetErrorString(res), 'LTR_Crates Error');

    if (CratesBox.Items.Count > 0) then
    begin             //   -     
       CratesBox.ItemIndex := 0;
       CratesBox.Enabled := true;
       CratesBoxChange(self);
    end
    else begin               //  -  - disabled
        ModulesBox.Enabled := false;
        CratesBox.Enabled := false;
        StartButton.Enabled :=false;
    end;
end;


//     (    FindLtrButtonClick)
//   LTR114  
procedure TLTR114TestForm.CratesBoxChange(Sender: TObject);
var
    hltr : TLTR;
    serial : PChar;
    i , res: integer;
    mid:array[0..MODULE_MAX-1]of WORD;
begin
    ModulesBox.Clear();
    serial := PChar(CratesBox.Items[CratesBox.ItemIndex]);


    LTR_Init(@hltr);
    hltr.cc:=CC_CONTROL;
    for i:=0 to SERIAL_NUMBER_SIZE-1 do     //   
        hltr.csn[i] := serial[i];
    res:=LTR_Open(@hltr);
    if (res=LTR_OK)then
		    res:=LTR_GetCrateModules(@hltr, @mid[0]);   //   
    if (res=LTR_OK) then
    begin
        for i:=0 to MODULE_MAX-1 do
            //   LTR114      
            if (mid[i]=LTR114_mid) then
            begin
               ModulesBox.Items.Add('Slot '+IntToStr(i+1))
            end;
    end;
    LTR_Close(@hltr);
    if (res<>LTR_OK) then
    begin
        Application.MessageBox(LTR114_GetErrorString(res), 'LTR_GetCrateModules Error');
    end;

    if (ModulesBox.Items.Count > 0) then
    begin
       ModulesBox.Enabled := true;
       ModulesBox.ItemIndex := 0;
       StartButton.Enabled := true;
    end
    else begin
       ModulesBox.Enabled := false;
       StartButton.Enabled := false;
    end;

end;

function TLTR114TestForm.ThreadIsRun : boolean;
begin
    crit_sect.Enter();
    Result:= thread_run;
    crit_sect.Leave();
end;

//  -    ( )   . 
procedure TLTR114TestForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
    if (ThreadIsRun()) then     //   
        StopButtonClick(self);   //

    while ThreadIsRun() do      //  
    begin
        Application.ProcessMessages();
        Sleep(200);
    end;
    crit_sect.Free();

end;

end.
